"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.cssSerializer = exports.ABELL_CSS_DATA_PREFIX = void 0;
/* eslint-disable @typescript-eslint/ban-ts-comment */
const stylis = __importStar(require("stylis"));
const postcss_selector_parser_1 = __importDefault(require("postcss-selector-parser"));
exports.ABELL_CSS_DATA_PREFIX = 'data-abell';
// mostly taken from https://github.com/vuejs/component-compiler-utils/blob/master/lib/stylePlugins/scoped.ts
// Removed some vue specific features
const cssSelectorTransformer = (scopingAttribute) => {
    return postcss_selector_parser_1.default((selectors) => {
        selectors.each((selector) => {
            // @ts-ignore
            let node = null;
            // find the last child node to insert attribute selector
            selector.each((n) => {
                if (n.type !== 'pseudo' && n.type !== 'combinator') {
                    node = n;
                }
            });
            if (node) {
                node.spaces.after = '';
            }
            else {
                // For deep selectors & standalone pseudo selectors,
                // the attribute selectors are prepended rather than appended.
                // So all leading spaces must be eliminated to avoid problems.
                selector.first.spaces.before = '';
            }
            selector.insertAfter(
            // @ts-ignore
            node, 
            // @ts-ignore
            postcss_selector_parser_1.default.attribute({
                attribute: scopingAttribute
            }));
        });
    });
};
const generateScopedSelector = (selector, attribute) => cssSelectorTransformer(attribute).processSync(selector);
const selectorPrefixer = (hash) => (element) => {
    // rule is the AST node which has the css selector
    if (element.type === 'rule') {
        // map over each existing select and prefix it
        if (typeof element.props !== 'string') {
            const newSelectors = element.props.map((selector) => {
                return generateScopedSelector(selector, `${exports.ABELL_CSS_DATA_PREFIX}-${hash}`);
            });
            // Mutate the old ast node with the new selectors
            element.props = newSelectors;
        }
    }
};
const cssSerializer = (cssString, hash) => {
    return stylis.serialize(stylis.compile(cssString), stylis.middleware([selectorPrefixer(hash), stylis.stringify]));
};
exports.cssSerializer = cssSerializer;
