/// <reference types="node" />
export declare type UserOptionsBase = {
    basePath?: string;
    filename?: string;
    allowRequire?: boolean;
    allowComponents?: boolean;
};
export interface UserOptionsAllowComponents extends UserOptionsBase {
    allowComponents: true;
}
export declare type UserOptions = UserOptionsAllowComponents | UserOptionsBase;
export declare type ContentBundle = {
    attributes: Record<string, unknown>;
    component: string;
    componentPath: string;
    content: string;
};
export interface StyleScriptsBundleInfo {
    styles: ContentBundle[];
    scripts: ContentBundle[];
    components?: StyleScriptsBundleInfo[];
    component: string;
    filepath: string;
}
export declare type OutputWithComponent = {
    html: string;
    components: StyleScriptsBundleInfo[];
};
export declare type NodeBuiltins = {
    console: {
        log: Console['log'];
    };
    __filename?: string;
    __dirname?: string;
    require?: (pathToRequire: string) => unknown;
};
export interface AcornNode extends acorn.Node {
    body: AcornNode[];
    expression: AcornNode;
}
